using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace TS_analyzer
{

	public class ts_analyzer : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label text;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ListBox f_in;
		private System.Windows.Forms.Button st;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Button end;
		private System.Windows.Forms.Button refresh;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.TextBox go;
		private System.Windows.Forms.Button browse;
		private search brow=new search();
		private info   run=new info();

		private System.ComponentModel.Container components = null;

		public ts_analyzer()
		{
			InitializeComponent();
		}


		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code

		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ts_analyzer));
			this.text = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.f_in = new System.Windows.Forms.ListBox();
			this.st = new System.Windows.Forms.Button();
			this.label13 = new System.Windows.Forms.Label();
			this.end = new System.Windows.Forms.Button();
			this.refresh = new System.Windows.Forms.Button();
			this.label14 = new System.Windows.Forms.Label();
			this.go = new System.Windows.Forms.TextBox();
			this.browse = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// text
			// 
			this.text.Location = new System.Drawing.Point(8, 8);
			this.text.Name = "text";
			this.text.Size = new System.Drawing.Size(128, 40);
			this.text.TabIndex = 0;
			this.text.Text = "This is a very simple program that analyze a Transport Stream";
			this.text.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 56);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(128, 40);
			this.label1.TabIndex = 1;
			this.label1.Text = "You can view each pachet or chose to write the info to a text file.";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(40, 112);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "INPUT FILE :";
			// 
			// f_in
			// 
			this.f_in.Location = new System.Drawing.Point(16, 136);
			this.f_in.Name = "f_in";
			this.f_in.Size = new System.Drawing.Size(128, 82);
			this.f_in.Sorted = true;
			this.f_in.TabIndex = 21;
			this.f_in.TabStop = false;
			this.f_in.SelectedIndexChanged += new System.EventHandler(this.verify);
			// 
			// st
			// 
			this.st.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(224)), ((System.Byte)(224)), ((System.Byte)(224)));
			this.st.Enabled = false;
			this.st.Location = new System.Drawing.Point(48, 272);
			this.st.Name = "st";
			this.st.Size = new System.Drawing.Size(72, 24);
			this.st.TabIndex = 22;
			this.st.Text = "START";
			this.st.Click += new System.EventHandler(this.st_Click);
			// 
			// label13
			// 
			this.label13.Font = new System.Drawing.Font("Arial", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label13.ForeColor = System.Drawing.Color.Blue;
			this.label13.Location = new System.Drawing.Point(16, 304);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(128, 40);
			this.label13.TabIndex = 23;
			this.label13.Text = "Program by Angel May 2004";
			this.label13.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// end
			// 
			this.end.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(224)), ((System.Byte)(224)), ((System.Byte)(224)));
			this.end.Location = new System.Drawing.Point(48, 352);
			this.end.Name = "end";
			this.end.Size = new System.Drawing.Size(72, 24);
			this.end.TabIndex = 24;
			this.end.Text = "EXIT";
			this.end.Click += new System.EventHandler(this.end_Click);
			// 
			// refresh
			// 
			this.refresh.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(224)), ((System.Byte)(224)), ((System.Byte)(224)));
			this.refresh.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.refresh.Location = new System.Drawing.Point(80, 216);
			this.refresh.Name = "refresh";
			this.refresh.Size = new System.Drawing.Size(64, 16);
			this.refresh.TabIndex = 25;
			this.refresh.TabStop = false;
			this.refresh.Text = "REFRESH";
			this.refresh.Click += new System.EventHandler(this.refresh_Click);
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(48, 242);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(56, 16);
			this.label14.TabIndex = 26;
			this.label14.Text = "OK to go :";
			// 
			// go
			// 
			this.go.BackColor = System.Drawing.Color.Red;
			this.go.Location = new System.Drawing.Point(104, 240);
			this.go.Name = "go";
			this.go.Size = new System.Drawing.Size(16, 20);
			this.go.TabIndex = 27;
			this.go.Text = "";
			// 
			// browse
			// 
			this.browse.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(224)), ((System.Byte)(224)), ((System.Byte)(224)));
			this.browse.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.browse.Location = new System.Drawing.Point(16, 216);
			this.browse.Name = "browse";
			this.browse.Size = new System.Drawing.Size(64, 16);
			this.browse.TabIndex = 28;
			this.browse.TabStop = false;
			this.browse.Text = "BROWSE";
			this.browse.Click += new System.EventHandler(this.browse_Click);
			// 
			// ts_analyzer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(255)));
			this.ClientSize = new System.Drawing.Size(160, 382);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.browse,
																		  this.go,
																		  this.label14,
																		  this.refresh,
																		  this.end,
																		  this.label13,
																		  this.st,
																		  this.f_in,
																		  this.label2,
																		  this.label1,
																		  this.text});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "ts_analyzer";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "TS";
			this.Load += new System.EventHandler(this.ts_analyzer_Load);
			this.ResumeLayout(false);

		}
		#endregion


		[STAThread]
		static void Main() 
		{
			Application.Run(new ts_analyzer());
		}

		private void end_Click(object sender, System.EventArgs e)
		{
			Dispose(true);
		}

		public void refresh_list()
		{
			f_in.Items.Clear();
			string[] files=Directory.GetFiles(brow.path,"*.ts");
			files=brow.trim_items(files);
			f_in.Items.AddRange(files);
		}

		private void refresh_Click(object sender, System.EventArgs e)
		{
			refresh_list();
			verify(sender,e);
		}

		private void verify(object sender, System.EventArgs e)
		{
			if (f_in.Text.Length>0) 
			{
				st.Enabled=true;
				go.BackColor=Color.Lime;
			}
			else 
			{
				st.Enabled=false;
				go.BackColor=Color.Red;
			}
		}

		private void st_Click(object sender, System.EventArgs e)
		{
			verify(sender,e);
			if (st.Enabled)
			{
				st.Enabled=false;
				this.Refresh();
				this.Hide();
				run=new info();
				run.Show();
				run.init(brow.path+f_in.Text,this);
				st.Enabled=true;
			}
		}

		private void ts_analyzer_Load(object sender, System.EventArgs e)
		{
			refresh_list();
		}

		private void browse_Click(object sender, System.EventArgs e)
		{
			brow.Show();
			brow.init(this);
			refresh_list();
		}
	

			}
}
